# DescribeInstanceTypes

## 1. API Description

This API (DescribeInstanceTypes) is used to query the model configuration of an instance.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

<mark style="color:blue;">Use</mark> <mark style="color:blue;">`DescribeInstanceTypes`</mark> <mark style="color:blue;">to query the configuration and performance information of an instance model. If you need to check the available instance models in a specific zone, please call</mark> <mark style="color:blue;">`DescribeAvailableResources.`</mark>
{% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name      | Required | Type             | Description                                                                              |
| ------------------- | -------- | ---------------- | ---------------------------------------------------------------------------------------- |
| imageId             | No       | String           | Instance models that support specified image.                                            |
| instanceTypeIds     | No       | Array of String  | <p>Instance model ID.</p><p>Maximum number: 100</p>                                      |
| minimumCpuCoreCount | No       | Integer          | <p>Desired minimum number of CPU cores.</p><p>Value range: positive integer.</p>         |
| maximumCpuCoreCount | No       | Integer          | <p>Desired maximum number of CPU cores.</p><p>Value range: positive integer.</p>         |
| minimumMemorySize   | No       | Integer          | <p>Desired minimum memory size.</p><p>Value range: positive integer.</p><p>Unit: GB.</p> |
| maximumMemorySize   | No       | Integer          | <p>Desired maximum memory size.</p><p>Value range: positive integer.</p><p>Unit: GB.</p> |
| minimumBandwidth    | No       | Integer          | <p>Desired minimum public inbound bandwidth cap.</p><p>Unit: Mbps.</p>                   |
| supportRaids        | No       | Array of Integer | <p>Supported RAID levels.</p><p>Value range: 0, 1, 5, 10.</p>                            |
| supportSubnet       | No       | Boolean          | Subnet supported or not.                                                                 |
| minimumDiskSize     | No       | Integer          | <p>Desired minimum disk size.</p><p>Value range: positive integer.</p><p>Unit: GB.</p>   |
| maximumDiskSize     | No       | Integer          | <p>Desired maximum memory size.</p><p>Value range: positive integer.</p><p>Unit: GB.</p> |
| isHA                | No       | Boolean          | High availability supported or not.                                                      |

## 3. Output Parameters

| Parameter Name | Type                                                                              | Description                                                                                                           |
| -------------- | --------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String                                                                            | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| instanceTypes  | Array of [InstanceType](/api-reference/compute/bmc/datastructure.md#instancetype) | Information on instance model.                                                                                        |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Query the instance models**

```json
POST /api/v2/bmc HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribeInstanceTypes
<Common Request Params>

Response:
{
  "requestId": "TE056C563-E5B1-46B5-9C5A-514B7501F420",
  "response": {
    "requestId": "TE056C563-E5B1-46B5-9C5A-514B7501F420",
    "instanceTypes": [
      {
        "imageIds": [
          "e3f1cf2e-8929-4b8a-8747-d0b779b770f7",
          "6059cf45-daf7-4954-80a2-346e8c3c5fd7"
        ],
        "instanceTypeId": "M9O",
        "description": "2x6248",
        "cpuCoreCount": 80,
        "cpuDetail": "1 × Intel® Xeon® CPU E3-1230 v5",
        "cpuCores": 2,
        "cpuThreads": 8,
        "baseFrequency": "3.40 GHz (Turbo 3.80 GHz)",
        "memorySize": 256,
        "maximumBandwidth": 10000,
        "supportRaids": [0,1,5,10],
        "supportSubnet": true,
        "isHA": true,
        "diskInfo": {
          "totalDiskSize": 4000,
          "diskDescription": "4x1.2TB SAS",
          "disks": [
            {
              "diskSize": 1000,
              "diskCount": 4
            }
          ]
        }
      },
      {
        "imageIds": [
          "f9f9f8a2-24a1-44dd-9f60-36c3bc5c0dae"
        ],
        "instanceTypeId": "MGI",
        "description": "2x6248",
        "cpuCoreCount": 80,
        "cpuDetail": "1 × Intel® Xeon® CPU E3-1230 v5",
        "cpuCores": 2,
        "cpuThreads": 8,
        "baseFrequency": "3.40 GHz (Turbo 3.80 GHz)",
        "memorySize": 256,
        "maximumBandwidth": 10000,
        "supportRaids": [0,1],
        "supportSubnet": true,
        "isHA": true,
        "diskInfo": {
          "totalDiskSize": 2000,
          "diskDescription": "2x1.2TB SAS",
          "disks": [
            {
              "diskSize": 1000,
              "diskCount": 2
            }
          ]
        }
      }
    ]
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code | Description |
| ---------------- | ---------- | ----------- |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.console.zenlayer.com/api-reference/compute/bmc/bare-metal-instance/describeinstancetypes.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
